require 'sugar'

express = require 'express'

path = require 'path'
form = require 'connect-form'
# https://github.com/rootslab/formaline
fs = require('fs')

ecoplus = require 'eco-plus'

http = require('http')
res = http.ServerResponse.prototype


create_app = (app_dir)->
  # Settings
  conf = JSON.parse fs.readFileSync(path.join(app_dir, 'config.json'), 'utf-8')
  unless process.env['NODE_ENV']? and process.env['NODE_ENV'] == 'production'
    conf.assets_url = '/'
  conf.posts_dir = path.join(app_dir, conf.posts_dir)
  

  # Create Server
  global.app = express.createServer(form({ keepExtensions: true }))
  app.conf = conf

  
  # Database
  # Don't need it for now
  #uri = process.env["MONGOHQ_URL"]
  #unless uri      
  #  uri = "mongodb://localhost/#{ conf.database_name }"
  #
  #console.log "Use database: #{uri}"
  #
  #app.mongoose = require 'mongoose'
  #app.db = app.mongoose.connect uri


  # Templates
  app.templates = ecoplus.templates path.join(app_dir, conf.templates_dir)
  # override res.render method 
  res.render = (name, context={}) ->
    @send ecoplus.render(name, context, app.templates)

  # Application configuration
  app.configure ->
    app.use express.methodOverride()
    app.use express.bodyParser()
    app.use express.cookieParser()
    app.use express.session({ secret: "this_is_super_secret_string", cookie: { maxAge: 86400000 } })
    app.use app.router
    app.use express.static(path.join(app_dir, 'static'))
    app.use express.errorHandler({ showStack: true, dumpExceptions: true })

  # Setting routes
  if conf.redirect_www
    app.get '/*', (req, res, next) ->
      if req.headers.host.match(/^www\./)
        res.redirect "http://#{req.headers.host.replace(/^www\./, '')}#{req.url}", 301
      else
        next()

  app.get '/*', (req, res, next) ->
    req.conf = app.conf
    next()

  app.posts = require './posts'
  
  app.get '/sitemap.xml', (req, res, next) ->
    render_posts = -> ("<url><loc>#{p.uri()}</loc><mobile:mobile/></url>" for p in app.posts).join('\n')
    res.send """<?xml version="1.0" encoding="UTF-8" ?>
                  <urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9"
                          xmlns:mobile="http://www.google.com/schemas/sitemap-mobile/1.0">
                    <url><loc>#{ app.conf.website_url }</loc><mobile:mobile/></url>
                    #{render_posts()}
                  </urlset>"""

  app.get '/js/render.js', (req, res) ->
    res.contentType 'application/javascript'
    res.send ecoplus.render_js(app.templates, app.conf)
  
  app.conf.modules.each (m) ->
    require path.join(app_dir, m)
  
  # 404 page handler
  
  app


module.exports =
  start: (app_dir, port) ->
    app = create_app(app_dir)
    app.listen(port)

