fs = require 'fs'
findit = require 'findit'
yaml = require 'yaml'
markdown = require 'github-flavored-markdown'

posts = []
findit.sync app.conf.posts_dir, (f) ->
  if f.endsWith('.md')
    src = fs.readFileSync f, 'utf-8'
    
    src_split = src.split('---')
    if src_split.length > 0
      meta = yaml.eval src_split[0]
      body = src_split[1]
    else
      meta = {}
      body = src_split[0]
    
    meta.date = meta.date.toDate()
    html_body = markdown.parse body
    
    posts.push Object.merge(meta, {body: html_body})

module.exports = posts


topics = (posts) ->
  result = []
  Object.each posts.groupBy('topic'), (topic, list) ->
    result.push
      name: topic
      posts: list.sortBy('date', desc=true)

  result.sortBy ((t) -> t.posts.first().date), desc=true
  

app.get '/', (req, res) ->
  res.render 'home/main', Object.merge(req, {topics: topics(app.posts)})


app.get '/posts.:format?', (req, res, next) ->
  if req.params.format == 'json'
    res.contentType 'application/json'
    res.send topics(app.posts)
  else
    next()


app.get '/posts/:slug.:format?', (req, res, next) ->
  post = app.posts.find (p) -> p.slug == req.params.slug
  if post?
    if req.params.format == 'json'
      res.contentType 'application/json'
      res.send post
    else if req.params.format == 'md'
      next()
    else
      res.render 'post/main', Object.merge(req, {title: post.title, post: post})
  else
    next()

